/*
 * Ported from Flashlight VNC ActionScript implementation:
 *     http://www.wizhelp.com/flashlight-vnc/
 *
 * Full attribution follows:
 *
 * -------------------------------------------------------------------------
 *
 * This DES class has been extracted from package Acme.Crypto for use in VNC.
 * The unnecessary odd parity code has been removed.
 *
 * These changes are:
 *  Copyright (C) 1999 AT&T Laboratories Cambridge.  All Rights Reserved.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *

 * DesCipher - the DES encryption method
 *
 * The meat of this code is by Dave Zimmerman <dzimm@widget.com>, and is:
 *
 * Copyright (c) 1996 Widget Workshop, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL or COMMERCIAL purposes and
 * without fee is hereby granted, provided that this copyright notice is kept 
 * intact. 
 * 
 * WIDGET WORKSHOP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. WIDGET WORKSHOP SHALL NOT BE LIABLE
 * FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  WIDGET WORKSHOP
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 *
 *
 * The rest is:
 *
 * Copyright (C) 1996 by Jef Poskanzer <jef@acme.com>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the ACME Labs Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.acme.com/java/
 */
"use strict";function DES(r){function n(r){var n,o,f,c,t,e,i,u,s,a,l=[],v=[],p=[];for(o=0,f=56;56>o;++o,f-=8)f+=-5>f?65:-3>f?31:-1>f?63:27===f?35:0,c=7&f,l[o]=0!==(r[f>>>3]&1<<c)?1:0;for(n=0;16>n;++n){for(c=n<<1,t=c+1,p[c]=p[t]=0,e=28;59>e;e+=28)for(o=e-28;e>o;++o)f=o+d[n],v[o]=e>f?l[f]:l[f-28];for(o=0;24>o;++o)0!==v[b[o]]&&(p[c]|=1<<23-o),0!==v[b[o+24]]&&(p[t]|=1<<23-o)}for(n=0,s=0,a=0;16>n;++n)i=p[s++],u=p[s++],h[a]=(16515072&i)<<6,h[a]|=(4032&i)<<10,h[a]|=(16515072&u)>>>10,h[a]|=(4032&u)>>>6,++a,h[a]=(258048&i)<<12,h[a]|=(63&i)<<16,h[a]|=(258048&u)>>>4,h[a]|=63&u,++a}function o(r){var n,o,f,c,t=0,e=r.slice(),i=0;for(o=e[t++]<<24|e[t++]<<16|e[t++]<<8|e[t++],f=e[t++]<<24|e[t++]<<16|e[t++]<<8|e[t++],c=252645135&(o>>>4^f),f^=c,o^=c<<4,c=65535&(o>>>16^f),f^=c,o^=c<<16,c=858993459&(f>>>2^o),o^=c,f^=c<<2,c=16711935&(f>>>8^o),o^=c,f^=c<<8,f=f<<1|f>>>31&1,c=2863311530&(o^f),o^=c,f^=c,o=o<<1|o>>>31&1,t=0;8>t;++t)c=f<<28|f>>>4,c^=h[i++],n=E[63&c],n|=y[c>>>8&63],n|=v[c>>>16&63],n|=a[c>>>24&63],c=f^h[i++],n|=S[63&c],n|=D[c>>>8&63],n|=p[c>>>16&63],n|=l[c>>>24&63],o^=n,c=o<<28|o>>>4,c^=h[i++],n=E[63&c],n|=y[c>>>8&63],n|=v[c>>>16&63],n|=a[c>>>24&63],c=o^h[i++],n|=S[63&c],n|=D[c>>>8&63],n|=p[c>>>16&63],n|=l[c>>>24&63],f^=n;for(f=f<<31|f>>>1,c=2863311530&(o^f),o^=c,f^=c,o=o<<31|o>>>1,c=16711935&(o>>>8^f),f^=c,o^=c<<8,c=858993459&(o>>>2^f),f^=c,o^=c<<2,c=65535&(f>>>16^o),o^=c,f^=c<<16,c=252645135&(f>>>4^o),o^=c,f^=c<<4,c=[f,o],t=0;8>t;t++)e[t]=(c[t>>>2]>>>8*(3-t%4))%256,e[t]<0&&(e[t]+=256);return e}function f(r){return o(r.slice(0,8)).concat(o(r.slice(8,16)))}var c,t,e,i,u,s,a,l,v,p,y,D,E,S,b=[13,16,10,23,0,4,2,27,14,5,20,9,22,18,11,3,25,7,15,6,26,19,12,1,40,51,30,36,46,54,29,39,50,44,32,47,43,48,38,55,33,52,45,41,49,35,28,31],d=[1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28],g=0,h=[];return c=65536,t=1<<24,e=c|t,i=4,u=1024,s=i|u,a=[e|u,g|g,c|g,e|s,e|i,c|s,g|i,c|g,g|u,e|u,e|s,g|u,t|s,e|i,t|g,g|i,g|s,t|u,t|u,c|u,c|u,e|g,e|g,t|s,c|i,t|i,t|i,c|i,g|g,g|s,c|s,t|g,c|g,e|s,g|i,e|g,e|u,t|g,t|g,g|u,e|i,c|g,c|u,t|i,g|u,g|i,t|s,c|s,e|s,c|i,e|g,t|s,t|i,g|s,c|s,e|u,g|s,t|u,t|u,g|g,c|i,c|u,g|g,e|i],c=1<<20,t=1<<31,e=c|t,i=32,u=32768,s=i|u,l=[e|s,t|u,g|u,c|s,c|g,g|i,e|i,t|s,t|i,e|s,e|u,t|g,t|u,c|g,g|i,e|i,c|u,c|i,t|s,g|g,t|g,g|u,c|s,e|g,c|i,t|i,g|g,c|u,g|s,e|u,e|g,g|s,g|g,c|s,e|i,c|g,t|s,e|g,e|u,g|u,e|g,t|u,g|i,e|s,c|s,g|i,g|u,t|g,g|s,e|u,c|g,t|i,c|i,t|s,t|i,c|i,c|u,g|g,t|u,g|s,t|g,e|i,e|s,c|u],c=1<<17,t=1<<27,e=c|t,i=8,u=512,s=i|u,v=[g|s,e|u,g|g,e|i,t|u,g|g,c|s,t|u,c|i,t|i,t|i,c|g,e|s,c|i,e|g,g|s,t|g,g|i,e|u,g|u,c|u,e|g,e|i,c|s,t|s,c|u,c|g,t|s,g|i,e|s,g|u,t|g,e|u,t|g,c|i,g|s,c|g,e|u,t|u,g|g,g|u,c|i,e|s,t|u,t|i,g|u,g|g,e|i,t|s,c|g,t|g,e|s,g|i,c|s,c|u,t|i,e|g,t|s,g|s,e|g,c|s,g|i,e|i,c|u],c=8192,t=1<<23,e=c|t,i=1,u=128,s=i|u,p=[e|i,c|s,c|s,g|u,e|u,t|s,t|i,c|i,g|g,e|g,e|g,e|s,g|s,g|g,t|u,t|i,g|i,c|g,t|g,e|i,g|u,t|g,c|i,c|u,t|s,g|i,c|u,t|u,c|g,e|u,e|s,g|s,t|u,t|i,e|g,e|s,g|s,g|g,g|g,e|g,c|u,t|u,t|s,g|i,e|i,c|s,c|s,g|u,e|s,g|s,g|i,c|g,t|i,c|i,e|u,t|s,c|i,c|u,t|g,e|i,g|u,t|g,c|g,e|u],c=1<<25,t=1<<30,e=c|t,i=256,u=1<<19,s=i|u,y=[g|i,c|s,c|u,e|i,g|u,g|i,t|g,c|u,t|s,g|u,c|i,t|s,e|i,e|u,g|s,t|g,c|g,t|u,t|u,g|g,t|i,e|s,e|s,c|i,e|u,t|i,g|g,e|g,c|s,c|g,e|g,g|s,g|u,e|i,g|i,c|g,t|g,c|u,e|i,t|s,c|i,t|g,e|u,c|s,t|s,g|i,c|g,e|u,e|s,g|s,e|g,e|s,c|u,g|g,t|u,e|g,g|s,c|i,t|i,g|u,g|g,t|u,c|s,t|i],c=1<<22,t=1<<29,e=c|t,i=16,u=16384,s=i|u,D=[t|i,e|g,g|u,e|s,e|g,g|i,e|s,c|g,t|u,c|s,c|g,t|i,c|i,t|u,t|g,g|s,g|g,c|i,t|s,g|u,c|u,t|s,g|i,e|i,e|i,g|g,c|s,e|u,g|s,c|u,e|u,t|g,t|u,g|i,e|i,c|u,e|s,c|g,g|s,t|i,c|g,t|u,t|g,g|s,t|i,e|s,c|u,e|g,c|s,e|u,g|g,e|i,g|i,g|u,e|g,c|s,g|u,c|i,t|s,g|g,e|u,t|g,c|i,t|s],c=1<<21,t=1<<26,e=c|t,i=2,u=2048,s=i|u,E=[c|g,e|i,t|s,g|g,g|u,t|s,c|s,e|u,e|s,c|g,g|g,t|i,g|i,t|g,e|i,g|s,t|u,c|s,c|i,t|u,t|i,e|g,e|u,c|i,e|g,g|u,g|s,e|s,c|u,g|i,t|g,c|u,t|g,c|u,c|g,t|s,t|s,e|i,e|i,g|i,c|i,t|g,t|u,c|g,e|u,g|s,c|s,e|u,g|s,t|i,e|s,e|g,c|u,g|g,g|i,e|s,g|g,c|s,e|g,g|u,t|i,t|u,g|u,c|i],c=1<<18,t=1<<28,e=c|t,i=64,u=4096,s=i|u,S=[t|s,g|u,c|g,e|s,t|g,t|s,g|i,t|g,c|i,e|g,e|s,c|u,e|u,c|s,g|u,g|i,e|g,t|i,t|u,g|s,c|u,c|i,e|i,e|u,g|s,g|g,g|g,e|i,t|i,t|u,c|s,c|g,c|s,c|g,e|u,g|u,g|i,e|i,g|u,c|s,t|u,g|i,t|i,e|g,e|i,t|g,c|g,t|s,g|g,e|s,c|i,t|i,e|g,t|u,t|s,g|g,e|s,c|u,c|u,g|s,g|s,c|i,t|g,e|u],n(r),{encrypt:f}}