/*
 * Websock: high-performance binary WebSockets
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * Websock is similar to the standard WebSocket object but Websock
 * enables communication with raw TCP sockets (i.e. the binary stream)
 * via websockify. This is accomplished by base64 encoding the data
 * stream between Websock and websockify.
 *
 * Websock has built-in receive queue buffering; the message event
 * does not contain actual data but is simply a notification that
 * there is new data available. Several rQ* methods are available to
 * read binary data off of the receive queue.
 */
function Websock(){"use strict";function e(){return v}function n(){return A}function t(){return D}function o(e){D=e}function r(){return A.length-D}function i(){return A[D]}function c(){return A[D++]}function u(e){0===D?A.unshift(e):(D-=1,A[D]=e)}function f(){return(A[D++]<<8)+A[D++]}function s(){return(A[D++]<<24)+(A[D++]<<16)+(A[D++]<<8)+A[D++]}function a(e){"undefined"==typeof e&&(e=r());var n=A.slice(D,D+e);return D+=e,n.map(function(e){return String.fromCharCode(e)}).join("")}function d(e){return"undefined"==typeof e&&(e=r()),D+=e,A.slice(D-e,D)}function l(e,n){return n?A.slice(D+e,D+n):A.slice(D+e)}function b(e,n,t){var o=A.length-D;if(n>o){if(t){if(t>D)throw"rQwait cannot backup "+t+" bytes";D-=t}return!0}return!1}function g(){return Base64.encode(v)}function S(e){A=A.concat(Base64.decode(e,0))}function W(){return 0!==y.bufferedAmount&&Util.Debug("bufferedAmount: "+y.bufferedAmount),y.bufferedAmount<Q.maxBufferedAmount?(v.length>0&&(y.send(g(v)),v=[]),!0):(Util.Info("Delaying send, bufferedAmount: "+y.bufferedAmount),!1)}function k(e){return v=v.concat(e),W()}function p(e){Q.send(e.split("").map(function(e){return e.charCodeAt(0)}))}function w(e){try{S(e.data),r()>0?(I.message(),A.length>O&&(A=A.slice(D),D=0)):Util.Debug("Ignoring empty message")}catch(n){"undefined"!=typeof n.stack?Util.Warn("recv_message, caught exception: "+n.stack):"undefined"!=typeof n.description?Util.Warn("recv_message, caught exception: "+n.description):Util.Warn("recv_message, caught exception:"+n),"undefined"!=typeof n.name?I.error(n.name+": "+n.message):I.error(n)}}function m(e,n){I[e]=n}function _(){A=[],D=0,v=[],y=null}function h(e){_(),y=B?{}:new WebSocket(e,"base64"),y.onmessage=w,y.onopen=function(){Util.Debug(">> WebSock.onopen"),y.protocol&&Util.Info("Server chose sub-protocol: "+y.protocol),I.open(),Util.Debug("<< WebSock.onopen")},y.onclose=function(e){Util.Debug(">> WebSock.onclose"),I.close(e),Util.Debug("<< WebSock.onclose")},y.onerror=function(e){Util.Debug(">> WebSock.onerror: "+e),I.error(e),Util.Debug("<< WebSock.onerror")}}function U(){y&&((y.readyState===WebSocket.OPEN||y.readyState===WebSocket.CONNECTING)&&(Util.Info("Closing WebSocket connection"),y.close()),y.onmessage=function(){})}function C(e){return B=!0,Q.send=e,Q.close=function(){},w}function E(){return Q.maxBufferedAmount=200,Q.get_sQ=e,Q.get_rQ=n,Q.get_rQi=t,Q.set_rQi=o,Q.rQlen=r,Q.rQpeek8=i,Q.rQshift8=c,Q.rQunshift8=u,Q.rQshift16=f,Q.rQshift32=s,Q.rQshiftStr=a,Q.rQshiftBytes=d,Q.rQslice=l,Q.rQwait=b,Q.flush=W,Q.send=k,Q.send_string=p,Q.on=m,Q.init=_,Q.open=h,Q.close=U,Q.testMode=C,Q}var Q={},y=null,A=[],D=0,O=1e4,v=[],I={message:function(){},open:function(){},close:function(){},error:function(){}},B=!1;return E()}window.WebSocket&&!window.WEB_SOCKET_FORCE_FLASH?Websock_native=!0:window.MozWebSocket&&!window.WEB_SOCKET_FORCE_FLASH?(Websock_native=!0,window.WebSocket=window.MozWebSocket):(Websock_native=!1,function(){function e(){return"undefined"!=typeof INCLUDE_URI?INCLUDE_URI:"include/"}var n="<script src='"+e(),t="'></script>",o="";window.WEB_SOCKET_SWF_LOCATION=e()+"web-socket-js/WebSocketMain.swf",Util.Engine.trident&&(Util.Debug("Forcing uncached load of WebSocketMain.swf"),window.WEB_SOCKET_SWF_LOCATION+="?"+Math.random()),o+=n+"web-socket-js/swfobject.js"+t,o+=n+"web-socket-js/web_socket.js"+t,document.write(o)}());