define("ace/mode/xml_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(e,t){"use strict";var n=e("../lib/oop"),r=e("./text_highlight_rules").TextHighlightRules,o=function(){var e="[_:a-zA-ZÀ-￿][-_:.a-zA-Z0-9À-￿]*";this.$rules={start:[{token:"string.cdata.xml",regex:"<\\!\\[CDATA\\[",next:"cdata"},{token:["punctuation.xml-decl.xml","keyword.xml-decl.xml"],regex:"(<\\?)(xml)(?=[\\s])",next:"xml_decl",caseInsensitive:!0},{token:["punctuation.instruction.xml","keyword.instruction.xml"],regex:"(<\\?)("+e+")",next:"processing_instruction"},{token:"comment.xml",regex:"<\\!--",next:"comment"},{token:["xml-pe.doctype.xml","xml-pe.doctype.xml"],regex:"(<\\!)(DOCTYPE)(?=[\\s])",next:"doctype",caseInsensitive:!0},{include:"tag"},{token:"text.end-tag-open.xml",regex:"</"},{token:"text.tag-open.xml",regex:"<"},{include:"reference"},{defaultToken:"text.xml"}],xml_decl:[{token:"entity.other.attribute-name.decl-attribute-name.xml",regex:"(?:"+e+":)?"+e},{token:"keyword.operator.decl-attribute-equals.xml",regex:"="},{include:"whitespace"},{include:"string"},{token:"punctuation.xml-decl.xml",regex:"\\?>",next:"start"}],processing_instruction:[{token:"punctuation.instruction.xml",regex:"\\?>",next:"start"},{defaultToken:"instruction.xml"}],doctype:[{include:"whitespace"},{include:"string"},{token:"xml-pe.doctype.xml",regex:">",next:"start"},{token:"xml-pe.xml",regex:"[-_a-zA-Z0-9:]+"},{token:"punctuation.int-subset",regex:"\\[",push:"int_subset"}],int_subset:[{token:"text.xml",regex:"\\s+"},{token:"punctuation.int-subset.xml",regex:"]",next:"pop"},{token:["punctuation.markup-decl.xml","keyword.markup-decl.xml"],regex:"(<\\!)("+e+")",push:[{token:"text",regex:"\\s+"},{token:"punctuation.markup-decl.xml",regex:">",next:"pop"},{include:"string"}]}],cdata:[{token:"string.cdata.xml",regex:"\\]\\]>",next:"start"},{token:"text.xml",regex:"\\s+"},{token:"text.xml",regex:"(?:[^\\]]|\\](?!\\]>))+"}],comment:[{token:"comment.xml",regex:"-->",next:"start"},{defaultToken:"comment.xml"}],reference:[{token:"constant.language.escape.reference.xml",regex:"(?:&#[0-9]+;)|(?:&#x[0-9a-fA-F]+;)|(?:&[a-zA-Z0-9_:\\.-]+;)"}],attr_reference:[{token:"constant.language.escape.reference.attribute-value.xml",regex:"(?:&#[0-9]+;)|(?:&#x[0-9a-fA-F]+;)|(?:&[a-zA-Z0-9_:\\.-]+;)"}],tag:[{token:["meta.tag.punctuation.tag-open.xml","meta.tag.punctuation.end-tag-open.xml","meta.tag.tag-name.xml"],regex:"(?:(<)|(</))((?:"+e+":)?"+e+")",next:[{include:"attributes"},{token:"meta.tag.punctuation.tag-close.xml",regex:"/?>",next:"start"}]}],tag_whitespace:[{token:"text.tag-whitespace.xml",regex:"\\s+"}],whitespace:[{token:"text.whitespace.xml",regex:"\\s+"}],string:[{token:"string.xml",regex:"'",push:[{token:"string.xml",regex:"'",next:"pop"},{defaultToken:"string.xml"}]},{token:"string.xml",regex:'"',push:[{token:"string.xml",regex:'"',next:"pop"},{defaultToken:"string.xml"}]}],attributes:[{token:"entity.other.attribute-name.xml",regex:"(?:"+e+":)?"+e},{token:"keyword.operator.attribute-equals.xml",regex:"="},{include:"tag_whitespace"},{include:"attribute_value"}],attribute_value:[{token:"string.attribute-value.xml",regex:"'",push:[{token:"string.attribute-value.xml",regex:"'",next:"pop"},{include:"attr_reference"},{defaultToken:"string.attribute-value.xml"}]},{token:"string.attribute-value.xml",regex:'"',push:[{token:"string.attribute-value.xml",regex:'"',next:"pop"},{include:"attr_reference"},{defaultToken:"string.attribute-value.xml"}]}]},this.constructor===o&&this.normalizeRules()};(function(){this.embedTagRules=function(e,t,n){this.$rules.tag.unshift({token:["meta.tag.punctuation.tag-open.xml","meta.tag."+n+".tag-name.xml"],regex:"(<)("+n+"(?=\\s|>|$))",next:[{include:"attributes"},{token:"meta.tag.punctuation.tag-close.xml",regex:"/?>",next:t+"start"}]}),this.$rules[n+"-end"]=[{include:"attributes"},{token:"meta.tag.punctuation.tag-close.xml",regex:"/?>",next:"start",onMatch:function(e,t,n){return n.splice(0),this.token}}],this.embedRules(e,t,[{token:["meta.tag.punctuation.end-tag-open.xml","meta.tag."+n+".tag-name.xml"],regex:"(</)("+n+"(?=\\s|>|$))",next:n+"-end"},{token:"string.cdata.xml",regex:"<\\!\\[CDATA\\["},{token:"string.cdata.xml",regex:"\\]\\]>"}])}}).call(r.prototype),n.inherits(o,r),t.XmlHighlightRules=o}),define("ace/mode/behaviour/xml",["require","exports","module","ace/lib/oop","ace/mode/behaviour","ace/token_iterator","ace/lib/lang"],function(e,t){"use strict";function n(e,t){return e.type.lastIndexOf(t+".xml")>-1}var r=e("../../lib/oop"),o=e("../behaviour").Behaviour,a=e("../../token_iterator").TokenIterator,i=(e("../../lib/lang"),function(){this.add("string_dquotes","insertion",function(e,t,r,o,i){if('"'==i||"'"==i){var l=i,u=o.doc.getTextRange(r.getSelectionRange());if(""!==u&&"'"!==u&&'"'!=u&&r.getWrapBehavioursEnabled())return{text:l+u+l,selection:!1};var s=r.getCursorPosition(),g=o.doc.getLine(s.row),c=g.substring(s.column,s.column+1),m=new a(o,s.row,s.column),d=m.getCurrentToken();if(c==l&&(n(d,"attribute-value")||n(d,"string")))return{text:"",selection:[1,1]};if(d||(d=m.stepBackward()),!d)return;for(;n(d,"tag-whitespace")||n(d,"whitespace");)d=m.stepBackward();var x=!c||c.match(/\s/);if(n(d,"attribute-equals")&&(x||">"==c)||n(d,"decl-attribute-equals")&&(x||"?"==c))return{text:l+l,selection:[1,1]}}}),this.add("string_dquotes","deletion",function(e,t,n,r,o){var a=r.doc.getTextRange(o);if(!o.isMultiLine()&&('"'==a||"'"==a)){var i=r.doc.getLine(o.start.row),l=i.substring(o.start.column+1,o.start.column+2);if(l==a)return o.end.column++,o}}),this.add("autoclosing","insertion",function(e,t,r,o,i){if(">"==i){var l=r.getCursorPosition(),u=new a(o,l.row,l.column),s=u.getCurrentToken()||u.stepBackward();if(!s||!(n(s,"tag-name")||n(s,"tag-whitespace")||n(s,"attribute-name")||n(s,"attribute-equals")||n(s,"attribute-value")))return;if(n(s,"reference.attribute-value"))return;if(n(s,"attribute-value")){var g=s.value.charAt(0);if('"'==g||"'"==g){var c=s.value.charAt(s.value.length-1),m=u.getCurrentTokenColumn()+s.value.length;if(m>l.column||m==l.column&&g!=c)return}}for(;!n(s,"tag-name");)s=u.stepBackward();var d=u.getCurrentTokenRow(),x=u.getCurrentTokenColumn();if(n(u.stepBackward(),"end-tag-open"))return;var h=s.value;if(d==l.row&&(h=h.substring(0,l.column-x)),this.voidElements.hasOwnProperty(h.toLowerCase()))return;return{text:"></"+h+">",selection:[1,1]}}}),this.add("autoindent","insertion",function(e,t,n,r,o){if("\n"==o){var i=n.getCursorPosition(),l=r.getLine(i.row),u=new a(r,i.row,i.column),s=u.getCurrentToken();if(s&&-1!==s.type.indexOf("tag-close")){if("/>"==s.value)return;for(;s&&-1===s.type.indexOf("tag-name");)s=u.stepBackward();if(!s)return;var g=s.value,c=u.getCurrentTokenRow();if(s=u.stepBackward(),!s||-1!==s.type.indexOf("end-tag"))return;if(this.voidElements&&!this.voidElements[g]){var m=r.getTokenAt(i.row,i.column+1),l=r.getLine(c),d=this.$getIndent(l),x=d+r.getTabString();return m&&"</"===m.value?{text:"\n"+x+"\n"+d,selection:[1,x.length,1,x.length]}:{text:"\n"+x}}}}})});r.inherits(i,o),t.XmlBehaviour=i}),define("ace/mode/folding/xml",["require","exports","module","ace/lib/oop","ace/lib/lang","ace/range","ace/mode/folding/fold_mode","ace/token_iterator"],function(e,t){"use strict";function n(e,t){return e.type.lastIndexOf(t+".xml")>-1}var r=e("../../lib/oop"),o=(e("../../lib/lang"),e("../../range").Range),a=e("./fold_mode").FoldMode,i=e("../../token_iterator").TokenIterator,l=t.FoldMode=function(e,t){a.call(this),this.voidElements=e||{},this.optionalEndTags=r.mixin({},this.voidElements),t&&r.mixin(this.optionalEndTags,t)};r.inherits(l,a);var u=function(){this.tagName="",this.closing=!1,this.selfClosing=!1,this.start={row:0,column:0},this.end={row:0,column:0}};(function(){this.getFoldWidget=function(e,t,n){var r=this._getFirstTagInLine(e,n);return r?r.closing||!r.tagName&&r.selfClosing?"markbeginend"==t?"end":"":!r.tagName||r.selfClosing||this.voidElements.hasOwnProperty(r.tagName.toLowerCase())?"":this._findEndTagInLine(e,n,r.tagName,r.end.column)?"":"start":""},this._getFirstTagInLine=function(e,t){for(var r=e.getTokens(t),o=new u,a=0;a<r.length;a++){var i=r[a];if(n(i,"tag-open")){if(o.end.column=o.start.column+i.value.length,o.closing=n(i,"end-tag-open"),i=r[++a],!i)return null;for(o.tagName=i.value,o.end.column+=i.value.length,a++;a<r.length;a++)if(i=r[a],o.end.column+=i.value.length,n(i,"tag-close")){o.selfClosing="/>"==i.value;break}return o}if(n(i,"tag-close"))return o.selfClosing="/>"==i.value,o;o.start.column+=i.value.length}return null},this._findEndTagInLine=function(e,t,r,o){for(var a=e.getTokens(t),i=0,l=0;l<a.length;l++){var u=a[l];if(i+=u.value.length,!(o>i)&&n(u,"end-tag-open")&&(u=a[l+1],u&&u.value==r))return!0}return!1},this._readTagForward=function(e){var t=e.getCurrentToken();if(!t)return null;var r=new u;do if(n(t,"tag-open"))r.closing=n(t,"end-tag-open"),r.start.row=e.getCurrentTokenRow(),r.start.column=e.getCurrentTokenColumn();else if(n(t,"tag-name"))r.tagName=t.value;else if(n(t,"tag-close"))return r.selfClosing="/>"==t.value,r.end.row=e.getCurrentTokenRow(),r.end.column=e.getCurrentTokenColumn()+t.value.length,e.stepForward(),r;while(t=e.stepForward());return null},this._readTagBackward=function(e){var t=e.getCurrentToken();if(!t)return null;var r=new u;do{if(n(t,"tag-open"))return r.closing=n(t,"end-tag-open"),r.start.row=e.getCurrentTokenRow(),r.start.column=e.getCurrentTokenColumn(),e.stepBackward(),r;n(t,"tag-name")?r.tagName=t.value:n(t,"tag-close")&&(r.selfClosing="/>"==t.value,r.end.row=e.getCurrentTokenRow(),r.end.column=e.getCurrentTokenColumn()+t.value.length)}while(t=e.stepBackward());return null},this._pop=function(e,t){for(;e.length;){var n=e[e.length-1];if(t&&n.tagName!=t.tagName){if(this.optionalEndTags.hasOwnProperty(n.tagName)){e.pop();continue}return null}return e.pop()}},this.getFoldWidgetRange=function(e,t,n){var r=this._getFirstTagInLine(e,n);if(!r)return null;var a,l=r.closing||r.selfClosing,u=[];if(l)for(var s=new i(e,n,r.end.column),g={row:n,column:r.start.column};a=this._readTagBackward(s);){if(a.selfClosing){if(u.length)continue;return a.start.column+=a.tagName.length+2,a.end.column-=2,o.fromPoints(a.start,a.end)}if(a.closing)u.push(a);else if(this._pop(u,a),0==u.length)return a.start.column+=a.tagName.length+2,a.start.row==a.end.row&&a.start.column<a.end.column&&(a.start.column=a.end.column),o.fromPoints(a.start,g)}else{var s=new i(e,n,r.start.column),c={row:n,column:r.start.column+r.tagName.length+2};for(r.start.row==r.end.row&&(c.column=r.end.column);a=this._readTagForward(s);){if(a.selfClosing){if(u.length)continue;return a.start.column+=a.tagName.length+2,a.end.column-=2,o.fromPoints(a.start,a.end)}if(a.closing){if(this._pop(u,a),0==u.length)return o.fromPoints(c,a.start)}else u.push(a)}}}}).call(l.prototype)}),define("ace/mode/xml",["require","exports","module","ace/lib/oop","ace/lib/lang","ace/mode/text","ace/mode/xml_highlight_rules","ace/mode/behaviour/xml","ace/mode/folding/xml","ace/worker/worker_client"],function(e,t){"use strict";var n=e("../lib/oop"),r=e("../lib/lang"),o=e("./text").Mode,a=e("./xml_highlight_rules").XmlHighlightRules,i=e("./behaviour/xml").XmlBehaviour,l=e("./folding/xml").FoldMode,u=e("../worker/worker_client").WorkerClient,s=function(){this.HighlightRules=a,this.$behaviour=new i,this.foldingRules=new l};n.inherits(s,o),function(){this.voidElements=r.arrayToMap([]),this.blockComment={start:"<!--",end:"-->"},this.createWorker=function(e){var t=new u(["ace"],"ace/mode/xml_worker","Worker");return t.attachToDocument(e.getDocument()),t.on("error",function(t){e.setAnnotations(t.data)}),t.on("terminate",function(){e.clearAnnotations()}),t},this.$id="ace/mode/xml"}.call(s.prototype),t.Mode=s});