/*
 * noVNC: HTML5 VNC client
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * See README.md for usage and integration instructions.
 */
function Display(e){"use strict";function t(){Util.Debug(">> Display.constructor");var e,t,r,a,o=Util.Engine;if(!l.target)throw"target must be set";if("string"==typeof l.target)throw"target must be a DOM element";if(e=l.target,!e.getContext)throw"no getContext method";if(s||(s=e.getContext("2d")),Util.Debug("User Agent: "+navigator.userAgent),o.gecko&&Util.Debug("Browser: gecko "+o.gecko),o.webkit&&Util.Debug("Browser: webkit "+o.webkit),o.trident&&Util.Debug("Browser: trident "+o.trident),o.presto&&Util.Debug("Browser: presto "+o.presto),i.clear(),!("createImageData"in s))throw"Canvas does not support createImageData";for(l.render_mode="canvas rendering",null===l.prefer_js&&(Util.Info("Prefering javascript operations"),l.prefer_js=!0),w=s.createImageData(16,16),r=[],t=0;256>t;t+=1)r.push(255);try{a=e.style.cursor,changeCursor(l.target,r,r,2,2,8,8),e.style.cursor?(null===l.cursor_uri&&(l.cursor_uri=!0),Util.Info("Data URI scheme cursor supported")):(null===l.cursor_uri&&(l.cursor_uri=!1),Util.Warn("Data URI scheme cursor not supported")),e.style.cursor=a}catch(u){Util.Error("Data URI scheme cursor test exception: "+u),l.cursor_uri=!1}return Util.Debug("<< Display.constructor"),i}var r,a,o,u,n,i={},l={},s=null,h=0,c=0,g={x:0,y:0,w:0,h:0},p={x1:0,y1:0,x2:-1,y2:-1},f="",y=null,w=null,d=0,x=0;return Util.conf_defaults(l,i,e,[["target","wo","dom",null,"Canvas element for rendering"],["context","ro","raw",null,"Canvas 2D context for rendering (read-only)"],["logo","rw","raw",null,'Logo to display when cleared: {"width": width, "height": height, "data": data}'],["true_color","rw","bool",!0,"Use true-color pixel data"],["colourMap","rw","arr",[],"Colour map array (when not true-color)"],["scale","rw","float",1,"Display area scale factor 0.0 - 1.0"],["viewport","rw","bool",!1,"Use a viewport set with viewportChange()"],["width","rw","int",null,"Display area width"],["height","rw","int",null,"Display area height"],["render_mode","ro","str","","Canvas rendering mode (read-only)"],["prefer_js","rw","str",null,"Prefer Javascript over canvas methods"],["cursor_uri","rw","raw",null,"Can we render cursor using data URI"]]),i.get_context=function(){return s},i.set_scale=function(e){n(e)},i.set_width=function(e){i.resize(e,c)},i.get_width=function(){return h},i.set_height=function(e){i.resize(h,e)},i.get_height=function(){return c},n=function(e){var t,r,a,o,u=["transform","WebkitTransform","MozTransform",null];for(t=l.target,r=u.shift();r&&"undefined"==typeof t.style[r];)r=u.shift();return null===r?(Util.Debug("No scaling support"),void 0):("undefined"==typeof e?e=l.scale:e>1?e=1:.1>e&&(e=.1),l.scale!==e&&(l.scale=e,a=t.width-t.width*e,o=t.height-t.height*e,t.style[r]="scale("+l.scale+") translate(-"+a+"px, -"+o+"px)"),void 0)},u=function(e){var t,r;t=l.true_color?e:l.colourMap[e[0]],r="rgb("+t[2]+","+t[1]+","+t[0]+")",r!==f&&(s.fillStyle=r,f=r)},i.viewportChange=function(e,t,r,a){var o,u,n,i,f,y,w,d=l.target,x=g,m=p,v=null;l.viewport||(Util.Debug("Setting viewport to full display region"),e=-x.w,t=-x.h,r=h,a=c),"undefined"==typeof e&&(e=0),"undefined"==typeof t&&(t=0),"undefined"==typeof r&&(r=x.w),"undefined"==typeof a&&(a=x.h),r>h&&(r=h),a>c&&(a=c),(x.w!==r||x.h!==a)&&(r<x.w&&m.x2>x.x+r-1&&(m.x2=x.x+r-1),x.w=r,a<x.h&&m.y2>x.y+a-1&&(m.y2=x.y+a-1),x.h=a,x.w>0&&x.h>0&&d.width>0&&d.height>0&&(v=s.getImageData(0,0,d.width<x.w?d.width:x.w,d.height<x.h?d.height:x.h)),d.width=x.w,d.height=x.h,v&&s.putImageData(v,0,0)),i=x.x+x.w-1,f=x.y+x.h-1,0>e&&x.x+e<0&&(e=-x.x),i+e>=h&&(e-=i+e-h+1),x.y+t<0&&(t=-x.y),f+t>=c&&(t-=f+t-c+1),(0!==e||0!==t)&&(Util.Debug("viewportChange deltaX: "+e+", deltaY: "+t),x.x+=e,i+=e,x.y+=t,f+=t,x.x>m.x1&&(m.x1=x.x),i<m.x2&&(m.x2=i),x.y>m.y1&&(m.y1=x.y),f<m.y2&&(m.y2=f),0>e?(u=0,y=-e):(u=x.w-e,y=e),0>t?(n=0,w=-t):(n=x.h-t,w=t),o=s.fillStyle,s.fillStyle="rgb(255,255,255)",0!==e&&(s.drawImage(d,0,0,x.w,x.h,-e,0,x.w,x.h),s.fillRect(u,0,y,x.h)),0!==t&&(s.drawImage(d,0,0,x.w,x.h,0,-t,x.w,x.h),s.fillRect(0,n,x.w,w)),s.fillStyle=o)},i.getCleanDirtyReset=function(){var e,t=g,r=p,a=[],o=t.x+t.w-1,u=t.y+t.h-1;return e={x:r.x1,y:r.y1,w:r.x2-r.x1+1,h:r.y2-r.y1+1},r.x1>=r.x2||r.y1>=r.y2?a.push({x:t.x,y:t.y,w:t.w,h:t.h}):(t.x<r.x1&&a.push({x:t.x,y:t.y,w:r.x1-t.x+1,h:t.h}),o>r.x2&&a.push({x:r.x2+1,y:t.y,w:o-r.x2,h:t.h}),t.y<r.y1&&a.push({x:r.x1,y:t.y,w:r.x2-r.x1+1,h:r.y1-t.y}),u>r.y2&&a.push({x:r.x1,y:r.y2+1,w:r.x2-r.x1+1,h:u-r.y2})),p={x1:t.x,y1:t.y,x2:t.x+t.w-1,y2:t.y+t.h-1},{cleanBox:e,dirtyBoxes:a}},i.absX=function(e){return e+g.x},i.absY=function(e){return e+g.y},i.resize=function(e,t){f="",h=e,c=t,n(l.scale),i.viewportChange()},i.clear=function(){l.logo?(i.resize(l.logo.width,l.logo.height),i.blitStringImage(l.logo.data,0,0)):(i.resize(640,20),s.clearRect(0,0,g.w,g.h))},i.fillRect=function(e,t,r,a,o){u(o),s.fillRect(e-g.x,t-g.y,r,a)},i.copyImage=function(e,t,r,a,o,u){var n=e-g.x,i=t-g.y,h=r-g.x,c=a-g.y;s.drawImage(l.target,n,i,o,u,h,c,o,u)},i.startTile=function(e,t,r,a,o){var u,n,h,c,g,p;if(d=e,x=t,y=16===r&&16===a?w:s.createImageData(r,a),u=y.data,l.prefer_js)for(n=l.true_color?o:l.colourMap[o[0]],h=n[2],c=n[1],g=n[0],p=0;r*a*4>p;p+=4)u[p]=h,u[p+1]=c,u[p+2]=g,u[p+3]=255;else i.fillRect(e,t,r,a,o)},i.subTile=function(e,t,r,a,o){var u,n,s,h,c,g,p,f,w,m,v;if(l.prefer_js)for(u=y.data,p=y.width,s=l.true_color?o:l.colourMap[o[0]],h=s[2],c=s[1],g=s[0],m=e+r,v=t+a,f=t;v>f;f+=1)for(w=e;m>w;w+=1)n=4*(w+f*p),u[n]=h,u[n+1]=c,u[n+2]=g,u[n+3]=255;else i.fillRect(d+e,x+t,r,a,o)},i.finishTile=function(){l.prefer_js&&s.putImageData(y,d-g.x,x-g.y)},r=function(e,t,r,a,o,u){var n,i,l,h,c=g;for(n=s.createImageData(r,a),h=n.data,i=0,l=u;r*a*4>i;i+=4,l+=3)h[i]=o[l],h[i+1]=o[l+1],h[i+2]=o[l+2],h[i+3]=255;s.putImageData(n,e-c.x,t-c.y)},a=function(e,t,r,a,o,u){var n,i,l,h,c=g;for(n=s.createImageData(r,a),h=n.data,i=0,l=u;r*a*4>i;i+=4,l+=4)h[i]=o[l+2],h[i+1]=o[l+1],h[i+2]=o[l],h[i+3]=255;s.putImageData(n,e-c.x,t-c.y)},o=function(e,t,r,a,o,u){var n,i,h,c,p,f;for(n=s.createImageData(r,a),c=n.data,f=l.colourMap,i=0,h=u;r*a*4>i;i+=4,h+=1)p=f[o[h]],c[i]=p[2],c[i+1]=p[1],c[i+2]=p[0],c[i+3]=255;s.putImageData(n,e-g.x,t-g.y)},i.blitImage=function(e,t,r,u,n,i){l.true_color?a(e,t,r,u,n,i):o(e,t,r,u,n,i)},i.blitRgbImage=function(e,t,a,u,n,i){l.true_color?r(e,t,a,u,n,i):o(e,t,a,u,n,i)},i.blitStringImage=function(e,t,r){var a=new Image;a.onload=function(){s.drawImage(a,t-g.x,r-g.y)},a.src=e},i.changeCursor=function(e,t,r,a,o,u){return l.cursor_uri===!1?(Util.Warn("changeCursor called but no cursor data URI support"),void 0):(l.true_color?changeCursor(l.target,e,t,r,a,o,u):changeCursor(l.target,e,t,r,a,o,u,l.colourMap),void 0)},i.defaultCursor=function(){l.target.style.cursor="default"},t()}function changeCursor(e,t,r,a,o,u,n,i){"use strict";var l,s,h,c,g,p,f,y,w,d,x=[];for(x.push16le=function(e){this.push(255&e,e>>8&255)},x.push32le=function(e){this.push(255&e,e>>8&255,e>>16&255,e>>24&255)},s=40,h=u*n*4,g=Math.ceil(u*n/8),c=Math.ceil(u*n/8),x.push16le(0),x.push16le(2),x.push16le(1),x.push(u),x.push(n),x.push(0),x.push(0),x.push16le(a),x.push16le(o),x.push32le(s+h+g+c),x.push32le(22),x.push32le(s),x.push32le(u),x.push32le(2*n),x.push16le(1),x.push16le(32),x.push32le(0),x.push32le(g+c),x.push32le(0),x.push32le(0),x.push32le(0),x.push32le(0),d=n-1;d>=0;d-=1)for(w=0;u>w;w+=1)f=d*Math.ceil(u/8)+Math.floor(w/8),y=r[f]<<w%8&128?255:0,i?(f=u*d+w,l=i[t[f]],x.push(l[2]),x.push(l[1]),x.push(l[0]),x.push(y)):(f=4*(u*d+w),x.push(t[f+2]),x.push(t[f+1]),x.push(t[f]),x.push(y));for(d=0;n>d;d+=1)for(w=0;w<Math.ceil(u/8);w+=1)x.push(0);for(d=0;n>d;d+=1)for(w=0;w<Math.ceil(u/8);w+=1)x.push(0);p="data:image/x-icon;base64,"+Base64.encode(x),e.style.cursor="url("+p+") "+a+" "+o+", default"}