/*
 * noVNC: HTML5 VNC client
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * See README.md for usage and integration instructions.
 *
 * TIGHT decoder portion:
 * (c) 2012 Michael Tinglof, Joe Balaz, Les Piech (Mercuri.ca)
 */
function RFB(e){"use strict";function t(){var e,t;for(Util.Debug(">> RFB.constructor"),e=0;e<W.length;e+=1)z[W[e][1]]=z[W[e][0]],q[W[e][1]]=W[e][0],G[W[e][1]]=[0,0];try{V=new Display({target:B.target})}catch(r){Util.Error("Display exception: "+r),c("fatal","No working Display")}return H=new Keyboard({target:B.focusContainer,onKeyPress:k}),K=new Mouse({target:B.target,onMouseButton:T,onMouseMove:I}),t=V.get_render_mode(),N=new Websock,N.on("message",l),N.on("open",function(){"connect"===M?c("ProtocolVersion","Starting VNC handshake"):a("Got unexpected WebSockets connection")}),N.on("close",function(e){e.code&&Util.Info("Close code: "+e.code+", reason: "+e.reason+", wasClean: "+e.wasClean),"disconnect"===M?c("disconnected","VNC disconnected"):"ProtocolVersion"===M?a("Failed to connect to server"):M in{failed:1,disconnected:1}?Util.Error("Received onclose while disconnected"):a("Server disconnected")}),N.on("error",function(e){a("WebSock error: "+e)}),s(),Websock_native?(Util.Info("Using native WebSockets"),c("loaded","noVNC ready: native WebSockets, "+t)):(Util.Warn("Using web-socket-js bridge. Flash version: "+Util.Flash.version),!Util.Flash||Util.Flash.version<9?c("fatal","WebSockets or <a href='http://get.adobe.com/flashplayer'>Adobe Flash</a> is required"):"file://"===document.location.href.substr(0,7)?c("fatal","'file://' URL is incompatible with Adobe Flash"):c("loaded","noVNC ready: WebSockets emulation, "+t)),Util.Debug("<< RFB.constructor"),x}function r(){Util.Debug(">> RFB.connect");var e;"undefined"!=typeof UsingSocketIO?e="http://"+C+":"+R+"/"+F:(e=B.encrypt?"wss://":"ws://",e+=C+":"+R+"/"+F),Util.Info("connecting to "+e),N.open(e),Util.Debug("<< RFB.connect")}function i(e,t){var r,i=[];for(r=0;r<e.length;r+=1)i.push(e.charCodeAt(r));return new DES(i).encrypt(t)}function n(){return lt.length>0?(N.send(lt),setTimeout(function(){N.send(y())},50),lt=[],!0):!1}function o(e){1===Z&&a("Tight protocol handler only implements true color mode");var t,r,i,n,o,s,c=-1,l=0,u=-1,f=N.get_rQ(),d=N.get_rQi();if(Y.bytes=1,N.rQwait("TIGHT compression-control",Y.bytes))return!1;var h=function(e){for(var t=0;4>t;t++)l>>t&1&&(Y.zlibs[t].reset(),Util.Info("Reset zlib stream "+t));var r=Y.zlibs[u].uncompress(e,0);return 0!==r.status&&Util.Error("Invalid data in zlib stream"),r.data},b=function(){var e=f[d+2]+1,t=e*Z;if(Y.bytes+=t,N.rQwait("TIGHT palette "+r,Y.bytes))return!1;var n=2>=e?1:8,o=Math.floor((Y.width*n+7)/8),c=!1;if(o*Y.height<12?(c=!0,i=[0,o*Y.height]):i=v(N.rQslice(3+t,3+t+3)),Y.bytes+=i[0]+i[1],N.rQwait("TIGHT "+r,Y.bytes))return!1;N.rQshiftBytes(3);var a=N.rQshiftBytes(t);N.rQshiftBytes(i[0]),s=c?N.rQshiftBytes(i[1]):h(N.rQshiftBytes(i[1]));var l,u,b,g,p,y,w,_=[];if(2===e)for(g=Math.floor((Y.width+7)/8),p=Math.floor(Y.width/8),u=0;u<Y.height;u++){for(l=0;p>l;l++)for(b=7;b>=0;b--)y=3*(u*Y.width+8*l+7-b),w=3*(s[u*g+l]>>b&1),_[y]=a[w],_[y+1]=a[w+1],_[y+2]=a[w+2];for(b=7;b>=8-Y.width%8;b--)y=3*(u*Y.width+8*l+7-b),w=3*(s[u*g+l]>>b&1),_[y]=a[w],_[y+1]=a[w+1],_[y+2]=a[w+2]}else for(u=0;u<Y.height;u++)for(l=0;l<Y.width;l++)y=3*(u*Y.width+l),w=3*s[u*Y.width+l],_[y]=a[w],_[y+1]=a[w+1],_[y+2]=a[w+2];return Y.imgQ.push({type:"rgb",img:{complete:!0,data:_},x:Y.x,y:Y.y,width:Y.width,height:Y.height}),!0},g=function(){var e=!1,t=Y.width*Y.height*Z;return 12>t?(e=!0,i=[0,t]):i=v(N.rQslice(1,4)),Y.bytes=1+i[0]+i[1],N.rQwait("TIGHT "+r,Y.bytes)?!1:(N.rQshiftBytes(1+i[0]),s=e?N.rQshiftBytes(i[1]):h(N.rQshiftBytes(i[1])),Y.imgQ.push({type:"rgb",img:{complete:!0,data:s},x:Y.x,y:Y.y,width:Y.width,height:Y.height}),!0)};if(t=N.rQpeek8(),l=15&t,t>>=4,u=3&t,8===t)r="fill";else if(9===t)r="jpeg";else if(10===t)r="png";else if(4&t)r="filter";else{if(!(4>t))throw"Illegal tight compression received, ctl: "+t;r="copy"}if(e&&("filter"===r||"copy"===r))throw"filter/copy received in tightPNG mode";switch(r){case"fill":Y.bytes+=Z;break;case"jpeg":Y.bytes+=3;break;case"png":Y.bytes+=3;break;case"filter":Y.bytes+=2;break;case"copy":}if(N.rQwait("TIGHT "+r,Y.bytes))return!1;switch(r){case"fill":N.rQshift8(),n=N.rQshiftBytes(Z),Y.imgQ.push({type:"fill",img:{complete:!0},x:Y.x,y:Y.y,width:Y.width,height:Y.height,color:[n[2],n[1],n[0]]});break;case"png":case"jpeg":if(i=v(N.rQslice(1,4)),Y.bytes=1+i[0]+i[1],N.rQwait("TIGHT "+r,Y.bytes))return!1;N.rQshiftBytes(1+i[0]),o=new Image,Y.imgQ.push({type:"img",img:o,x:Y.x,y:Y.y}),o.src="data:image/"+r+Q(N.rQshiftBytes(i[1])),o=null;break;case"filter":if(c=f[d+1],1!==c)throw"Unsupported tight subencoding received, filter: "+c;if(!b())return!1;break;case"copy":if(!g())return!1}return Y.bytes=0,Y.rects-=1,!0}var s,c,a,l,u,f,d,h,b,g,p,y,w,_,m,v,Q,U,k,T,I,S,x={},B={},C="",R=5900,D="",F="",M="disconnected",E=0,A=3.8,P="",W=[["COPYRECT",1],["TIGHT",7],["TIGHT_PNG",-260],["HEXTILE",5],["RRE",2],["RAW",0],["DesktopSize",-223],["Cursor",-239],["JPEG_quality_med",-26],["compress_hi",-247],["last_rect",-224]],z={},q={},G={},N=null,V=null,H=null,K=null,O=null,j=null,L=null,X=null,Y={rects:0,subrects:0,lines:0,tiles:0,bytes:0,x:0,y:0,width:0,height:0,encoding:0,subencoding:-1,background:null,imgQ:[],zlibs:[]},J=4,Z=3,$=0,et=0,tt="",rt=40,it=0,nt=100,ot={last_fbu:0,fbu_total:0,fbu_total_cnt:0,full_fbu_total:0,full_fbu_cnt:0,fbu_rt_start:0,fbu_rt_total:0,fbu_rt_cnt:0,pixels:0},st=!1,ct=Websock_native?10:25,at=0,lt=[],ut=!1,ft={};return Util.conf_defaults(B,x,e,[["target","wo","dom",null,"VNC display rendering Canvas object"],["focusContainer","wo","dom",document,"DOM element that captures keyboard input"],["encrypt","rw","bool",!1,"Use TLS/SSL/wss encryption"],["true_color","rw","bool",!0,"Request true color pixel data"],["local_cursor","rw","bool",!1,"Request locally rendered cursor"],["shared","rw","bool",!0,"Request shared mode"],["view_only","rw","bool",!1,"Disable client mouse/keyboard"],["connectTimeout","rw","int",ct,"Time (s) to wait for connection"],["disconnectTimeout","rw","int",10,"Time (s) to wait for disconnection"],["viewportDrag","rw","bool",!1,"Move the viewport on mouse drags"],["check_rate","rw","int",217,"Timing (ms) of send/receive check"],["fbu_req_rate","rw","int",1413,"Timing (ms) of frameBufferUpdate requests"],["onUpdateState","rw","func",function(){},"onUpdateState(rfb, state, oldstate, statusMsg): RFB state update/change "],["onPasswordRequired","rw","func",function(){},"onPasswordRequired(rfb): VNC password is required "],["onClipboard","rw","func",function(){},"onClipboard(rfb, text): RFB clipboard contents received"],["onBell","rw","func",function(){},"onBell(rfb): RFB Bell message received "],["onFBUReceive","rw","func",function(){},"onFBUReceive(rfb, fbu): RFB FBU received but not yet processed "],["onFBUComplete","rw","func",function(){},"onFBUComplete(rfb, fbu): RFB FBU received and processed "],["updateState","rw","func",function(){},"obsolete, use onUpdateState"],["clipboardReceive","rw","func",function(){},"obsolete, use onClipboard"]]),x.set_local_cursor=function(e){!e||e in{0:1,no:1,"false":1}?B.local_cursor=!1:V.get_cursor_uri()?B.local_cursor=!0:Util.Warn("Browser does not support local cursor")},x.get_display=function(){return V},x.get_keyboard=function(){return H},x.get_mouse=function(){return K},s=function(){var e;for(N.init(),Y.rects=0,Y.subrects=0,Y.lines=0,Y.tiles=0,Y.imgQ=[],Y.zlibs=[],at=0,lt=[],e=0;e<W.length;e+=1)G[W[e][1]][0]=0;for(e=0;4>e;e++)Y.zlibs[e]=new TINF,Y.zlibs[e].init()},h=function(){var e,t;for(Util.Info("Encoding stats for this connection:"),e=0;e<W.length;e+=1)t=G[W[e][1]],t[0]+t[1]>0&&Util.Info("    "+W[e][0]+": "+t[0]+" rects");for(Util.Info("Encoding stats since page load:"),e=0;e<W.length;e+=1)t=G[W[e][1]],t[0]+t[1]>0&&Util.Info("    "+W[e][0]+": "+t[1]+" rects")},c=function(e,t){var i,n,o=M;if(e===o)return Util.Debug("Already in state '"+e+"', ignoring."),void 0;switch(e in{disconnected:1,loaded:1,connect:1,disconnect:1,failed:1,fatal:1}&&(O&&(clearInterval(O),O=null),X&&(clearInterval(X),X=null),V&&V.get_context()&&(H.ungrab(),K.ungrab(),V.defaultCursor(),("debug"!==Util.get_logging()||"loaded"===e)&&V.clear()),N.close()),"fatal"===o&&Util.Error("Fatal error, cannot continue"),i="failed"===e||"fatal"===e?Util.Error:Util.Warn,M="failed"===o&&"disconnected"===e?"failed":e,n="undefined"!=typeof t?" Msg: "+t:"",i("New state '"+M+"', was '"+o+"'."+n),j&&"connect"!==M&&(Util.Debug("Clearing connect timer"),clearInterval(j),j=null),L&&"disconnect"!==M&&(Util.Debug("Clearing disconnect timer"),clearInterval(L),L=null),e){case"normal":("disconnected"===o||"failed"===o)&&Util.Error("Invalid transition from 'disconnected' or 'failed' to 'normal'");break;case"connect":j=setTimeout(function(){a("Connect timeout")},1e3*B.connectTimeout),s(),r();break;case"disconnect":st||(L=setTimeout(function(){a("Disconnect timeout")},1e3*B.disconnectTimeout)),h();break;case"failed":"disconnected"===o&&Util.Error("Invalid transition from 'disconnected' to 'failed'"),"normal"===o&&Util.Error("Error while connected."),"init"===o&&Util.Error("Error while initializing."),setTimeout(function(){c("disconnected")},50)}"failed"===o&&"disconnected"===e?(B.updateState(x,e,o),B.onUpdateState(x,e,o)):(B.updateState(x,e,o,t),B.onUpdateState(x,e,o,t))},a=function(e){return c("failed",e),!1},l=function(){if(0===N.rQlen())return Util.Warn("handle_message called on empty receive queue"),void 0;switch(M){case"disconnected":case"failed":Util.Error("Got data while disconnected");break;case"normal":f()&&N.rQlen()>0&&(null===X?(Util.Debug("More data to process, creating timer"),X=setTimeout(function(){X=null,l()},10)):Util.Debug("More data to process, existing timer"));break;default:u()}},S=function(){var e;"normal"!==M||ut||n()||(e=(new Date).getTime(),e>it+B.fbu_req_rate&&(it=e,N.send(y()))),setTimeout(S,B.check_rate)},k=function(e,t){var r;B.view_only||(r=w(e,t),r=r.concat(y()),N.send(r))},T=function(e,t,r,i){if(r?at|=i:at^=i,B.viewportDrag){if(r&&!ut)return ut=!0,ft={x:e,y:t},void 0;ut=!1,N.send(y())}B.view_only||(lt=lt.concat(_(V.absX(e),V.absY(t))),n())},I=function(e,t){var r,i;return ut?(r=ft.x-e,i=ft.y-t,ft={x:e,y:t},V.viewportChange(r,i),void 0):(B.view_only||(lt=lt.concat(_(V.absX(e),V.absY(t)))),void 0)},u=function(){var e,t,r,n,o,s,l,f,d,h,p,w,_,m,v,Q,k,T,I,C,R;switch(M){case"ProtocolVersion":if(N.rQlen()<12)return a("Incomplete protocol version");switch(n=N.rQshiftStr(12).substr(4,7),Util.Info("Server ProtocolVersion: "+n),n){case"003.003":E=3.3;break;case"003.006":E=3.3;break;case"003.007":E=3.7;break;case"003.008":E=3.8;break;case"004.000":E=3.8;break;default:return a("Invalid server version "+n)}E>A&&(E=A),st||(O=setInterval(function(){N.flush()},50)),o="00"+parseInt(E,10)+".00"+10*E%10,N.send_string("RFB "+o+"\n"),c("Security","Sent ProtocolVersion: "+o);break;case"Security":if(E>=3.7){if(f=N.rQshift8(),N.rQwait("security type",f,1))return!1;if(0===f)return e=N.rQshift32(),t=N.rQshiftStr(e),a("Security failure: "+t);for(P=0,l=N.rQshiftBytes(f),Util.Debug("Server security types: "+l),s=0;s<l.length;s+=1)l[s]>P&&l[s]<3&&(P=l[s]);if(0===P)return a("Unsupported security types: "+l);N.send([P])}else{if(N.rQwait("security scheme",4))return!1;P=N.rQshift32()}c("Authentication","Authenticating using scheme: "+P),u();break;case"Authentication":switch(P){case 0:return N.rQwait("auth reason",4)?!1:(e=N.rQshift32(),t=N.rQshiftStr(e),a("Auth failure: "+t));case 1:if(E>=3.8)return c("SecurityResult"),void 0;break;case 2:return 0===D.length?(c("password","Password Required"),B.onPasswordRequired(x),void 0):N.rQwait("auth challenge",16)?!1:(d=N.rQshiftBytes(16),h=i(D,d),N.send(h),c("SecurityResult"),void 0);default:return a("Unsupported auth scheme: "+P),void 0}c("ClientInitialisation","No auth required"),u();break;case"SecurityResult":if(N.rQwait("VNC auth response ",4))return!1;switch(N.rQshift32()){case 0:break;case 1:if(E>=3.8){if(r=N.rQshift32(),N.rQwait("SecurityResult reason",r,8))return!1;t=N.rQshiftStr(r),a(t)}else a("Authentication failed");return;case 2:return a("Too many auth attempts")}c("ClientInitialisation","Authentication OK"),u();break;case"ClientInitialisation":N.send([B.shared?1:0]),c("ServerInitialisation","Authentication OK");break;case"ServerInitialisation":if(N.rQwait("server initialization",24))return!1;$=N.rQshift16(),et=N.rQshift16(),p=N.rQshift8(),w=N.rQshift8(),_=N.rQshift8(),C=N.rQshift8(),m=N.rQshift16(),v=N.rQshift16(),Q=N.rQshift16(),k=N.rQshift8(),T=N.rQshift8(),I=N.rQshift8(),N.rQshiftStr(3),Util.Info("Screen: "+$+"x"+et+", bpp: "+p+", depth: "+w+", big_endian: "+_+", true_color: "+C+", red_max: "+m+", green_max: "+v+", blue_max: "+Q+", red_shift: "+k+", green_shift: "+T+", blue_shift: "+I),0!==_&&Util.Warn("Server native endian is not little endian"),16!==k&&Util.Warn("Server native red-shift is not 16"),0!==I&&Util.Warn("Server native blue-shift is not 0"),R=N.rQshift32(),tt=N.rQshiftStr(R),B.true_color&&"Intel(r) AMT KVM"===tt&&(Util.Warn("Intel AMT KVM only support 8/16 bit depths. Disabling true color"),B.true_color=!1),V.set_true_color(B.true_color),V.resize($,et),H.grab(),K.grab(),B.true_color?(J=4,Z=3):(J=1,Z=1),h=b(),h=h.concat(g()),h=h.concat(y()),ot.fbu_rt_start=(new Date).getTime(),N.send(h),setTimeout(S,B.check_rate),setTimeout(U,rt),B.encrypt?c("normal","Connected (encrypted) to: "+tt):c("normal","Connected (unencrypted) to: "+tt)}},f=function(){var e,t,r,i,n,o,s,c,l,u=!0;switch(e=Y.rects>0?0:N.rQshift8()){case 0:u=d();break;case 1:if(Util.Debug("SetColourMapEntries"),N.rQshift8(),n=N.rQshift16(),o=N.rQshift16(),N.rQwait("SetColourMapEntries",6*o,6))return!1;for(i=0;o>i;i+=1)s=N.rQshift16(),s=parseInt(s/256,10),c=parseInt(N.rQshift16()/256,10),l=parseInt(N.rQshift16()/256,10),V.set_colourMap([l,c,s],n+i);Util.Debug("colourMap: "+V.get_colourMap()),Util.Info("Registered "+o+" colourMap entries");break;case 2:Util.Debug("Bell"),B.onBell(x);break;case 3:if(Util.Debug("ServerCutText"),N.rQwait("ServerCutText header",7,1))return!1;if(N.rQshiftBytes(3),t=N.rQshift32(),N.rQwait("ServerCutText",t,8))return!1;r=N.rQshiftStr(t),B.clipboardReceive(x,r),B.onClipboard(x,r);break;default:a("Disconnected: illegal server message type "+e),Util.Debug("ws.rQslice(0,30):"+N.rQslice(0,30))}return u},d=function(){var e,t,r,i=!0;if(0===Y.rects){if(N.rQwait("FBU header",3))return N.rQunshift8(0),!1;N.rQshift8(),Y.rects=N.rQshift16(),Y.bytes=0,ot.cur_fbu=0,ot.fbu_rt_start>0&&(e=(new Date).getTime(),Util.Info("First FBU latency: "+(e-ot.fbu_rt_start)))}for(;Y.rects>0;){if("normal"!==M)return!1;if(N.rQwait("FBU",Y.bytes))return!1;if(0===Y.bytes){if(N.rQwait("rect header",12))return!1;if(t=N.rQshiftBytes(12),Y.x=(t[0]<<8)+t[1],Y.y=(t[2]<<8)+t[3],Y.width=(t[4]<<8)+t[5],Y.height=(t[6]<<8)+t[7],Y.encoding=parseInt((t[8]<<24)+(t[9]<<16)+(t[10]<<8)+t[11],10),B.onFBUReceive(x,{x:Y.x,y:Y.y,width:Y.width,height:Y.height,encoding:Y.encoding,encodingName:q[Y.encoding]}),!q[Y.encoding])return a("Disconnected: unsupported encoding "+Y.encoding),!1}if(ot.last_fbu=(new Date).getTime(),i=z[Y.encoding](),e=(new Date).getTime(),ot.cur_fbu+=e-ot.last_fbu,i&&(G[Y.encoding][0]+=1,G[Y.encoding][1]+=1,ot.pixels+=Y.width*Y.height),(0===Y.rects||ot.pixels>=$*et)&&((Y.width===$&&Y.height===et||ot.fbu_rt_start>0)&&(ot.full_fbu_total+=ot.cur_fbu,ot.full_fbu_cnt+=1,Util.Info("Timing of full FBU, cur: "+ot.cur_fbu+", total: "+ot.full_fbu_total+", cnt: "+ot.full_fbu_cnt+", avg: "+ot.full_fbu_total/ot.full_fbu_cnt)),ot.fbu_rt_start>0&&(r=e-ot.fbu_rt_start,ot.fbu_rt_total+=r,ot.fbu_rt_cnt+=1,Util.Info("full FBU round-trip, cur: "+r+", total: "+ot.fbu_rt_total+", cnt: "+ot.fbu_rt_cnt+", avg: "+ot.fbu_rt_total/ot.fbu_rt_cnt),ot.fbu_rt_start=0)),!i)return i}return B.onFBUComplete(x,{x:Y.x,y:Y.y,width:Y.width,height:Y.height,encoding:Y.encoding,encodingName:q[Y.encoding]}),!0},z.RAW=function(){var e,t;return 0===Y.lines&&(Y.lines=Y.height),Y.bytes=Y.width*J,N.rQwait("RAW",Y.bytes)?!1:(e=Y.y+(Y.height-Y.lines),t=Math.min(Y.lines,Math.floor(N.rQlen()/(Y.width*J))),V.blitImage(Y.x,e,Y.width,t,N.get_rQ(),N.get_rQi()),N.rQshiftBytes(Y.width*t*J),Y.lines-=t,Y.lines>0?Y.bytes=Y.width*J:(Y.rects-=1,Y.bytes=0),!0)},z.COPYRECT=function(){var e,t;return N.rQwait("COPYRECT",4)?!1:(e=N.rQshift16(),t=N.rQshift16(),V.copyImage(e,t,Y.x,Y.y,Y.width,Y.height),Y.rects-=1,Y.bytes=0,!0)},z.RRE=function(){var e,t,r,i,n,o;if(0===Y.subrects){if(N.rQwait("RRE",4+J))return!1;Y.subrects=N.rQshift32(),e=N.rQshiftBytes(J),V.fillRect(Y.x,Y.y,Y.width,Y.height,e)}for(;Y.subrects>0&&N.rQlen()>=J+8;)e=N.rQshiftBytes(J),t=N.rQshift16(),r=N.rQshift16(),i=N.rQshift16(),n=N.rQshift16(),V.fillRect(Y.x+t,Y.y+r,i,n,e),Y.subrects-=1;return Y.subrects>0?(o=Math.min(nt,Y.subrects),Y.bytes=(J+8)*o):(Y.rects-=1,Y.bytes=0),!0},z.HEXTILE=function(){var e,t,r,i,n,o,s,c,l,u,f,d,h,b,g,p,y,w=N.get_rQ(),_=N.get_rQi();for(0===Y.tiles&&(Y.tiles_x=Math.ceil(Y.width/16),Y.tiles_y=Math.ceil(Y.height/16),Y.total_tiles=Y.tiles_x*Y.tiles_y,Y.tiles=Y.total_tiles);Y.tiles>0;){if(Y.bytes=1,N.rQwait("HEXTILE subencoding",Y.bytes))return!1;if(e=w[_],e>30)return a("Disconnected: illegal hextile subencoding "+e),!1;if(t=0,i=Y.total_tiles-Y.tiles,n=i%Y.tiles_x,c=Math.floor(i/Y.tiles_x),o=Y.x+16*n,l=Y.y+16*c,s=Math.min(16,Y.x+Y.width-o),u=Math.min(16,Y.y+Y.height-l),1&e)Y.bytes+=s*u*J;else if(2&e&&(Y.bytes+=J),4&e&&(Y.bytes+=J),8&e){if(Y.bytes+=1,N.rQwait("hextile subrects header",Y.bytes))return!1;t=w[_+Y.bytes-1],Y.bytes+=16&e?t*(J+2):2*t}if(N.rQwait("hextile",Y.bytes))return!1;if(Y.subencoding=w[_],_+=1,0===Y.subencoding)1&Y.lastsubencoding?Util.Debug("     Ignoring blank after RAW"):V.fillRect(o,l,s,u,Y.background);else if(1&Y.subencoding)V.blitImage(o,l,s,u,w,_),_+=Y.bytes-1;else{if(2&Y.subencoding&&(Y.background=w.slice(_,_+J),_+=J),4&Y.subencoding&&(Y.foreground=w.slice(_,_+J),_+=J),V.startTile(o,l,s,u,Y.background),8&Y.subencoding)for(t=w[_],_+=1,d=0;t>d;d+=1)16&Y.subencoding?(r=w.slice(_,_+J),_+=J):r=Y.foreground,f=w[_],_+=1,h=f>>4,b=15&f,g=w[_],_+=1,p=(g>>4)+1,y=(15&g)+1,V.subTile(h,b,p,y,r);V.finishTile()}N.set_rQi(_),Y.lastsubencoding=Y.subencoding,Y.bytes=0,Y.tiles-=1}return 0===Y.tiles&&(Y.rects-=1),!0},v=function(e){var t=1,r=0;return r+=127&e[0],128&e[0]&&(t+=1,r+=(127&e[1])<<7,128&e[1]&&(t+=1,r+=e[2]<<14)),[t,r]},Q=function(e){return";base64,"+Base64.encode(e)},U=function(){var e,t,r;if(r=V.get_context(),"normal"===M){for(t=Y.imgQ;t.length>0&&t[0].img.complete;)e=t.shift(),"fill"===e.type?V.fillRect(e.x,e.y,e.width,e.height,e.color):"rgb"===e.type?V.blitRgbImage(e.x,e.y,e.width,e.height,e.img.data,0):r.drawImage(e.img,e.x,e.y);setTimeout(U,rt)}},z.TIGHT=function(){return o(!1)},z.TIGHT_PNG=function(){return o(!0)},z.last_rect=function(){return Util.Debug(">> set_desktopsize"),Y.rects=0,Util.Debug("<< set_desktopsize"),!0},z.DesktopSize=function(){return Util.Debug(">> set_desktopsize"),$=Y.width,et=Y.height,V.resize($,et),ot.fbu_rt_start=(new Date).getTime(),N.send(y()),Y.bytes=0,Y.rects-=1,Util.Debug("<< set_desktopsize"),!0},z.Cursor=function(){var e,t,r,i,n,o;return e=Y.x,t=Y.y,r=Y.width,i=Y.height,n=r*i*J,o=Math.floor((r+7)/8)*i,Y.bytes=n+o,N.rQwait("cursor encoding",Y.bytes)?!1:(V.changeCursor(N.rQshiftBytes(n),N.rQshiftBytes(o),e,t,r,i),Y.bytes=0,Y.rects-=1,!0)},z.JPEG_quality_lo=function(){Util.Error("Server sent jpeg_quality pseudo-encoding")},z.compress_lo=function(){Util.Error("Server sent compress level pseudo-encoding")},b=function(){var e;return e=[0],e.push8(0),e.push8(0),e.push8(0),e.push8(8*J),e.push8(8*Z),e.push8(0),e.push8(B.true_color?1:0),e.push16(255),e.push16(255),e.push16(255),e.push8(16),e.push8(8),e.push8(0),e.push8(0),e.push8(0),e.push8(0),e},g=function(){var e,t,r=[];for(t=0;t<W.length;t+=1)"Cursor"!==W[t][0]||B.local_cursor?r.push(W[t][1]):Util.Debug("Skipping Cursor pseudo-encoding");for(e=[2],e.push8(0),e.push16(r.length),t=0;t<r.length;t+=1)e.push32(r[t]);return e},p=function(e,t,r,i,n){"undefined"==typeof t&&(t=0),"undefined"==typeof r&&(r=0),"undefined"==typeof i&&(i=$),"undefined"==typeof n&&(n=et);var o;return o=[3],o.push8(e),o.push16(t),o.push16(r),o.push16(i),o.push16(n),o},y=function(){var e,t,r,i=V.getCleanDirtyReset(),n=[];for(t=i.cleanBox,t.w>0&&t.h>0&&(n=n.concat(p(1,t.x,t.y,t.w,t.h))),e=0;e<i.dirtyBoxes.length;e++)r=i.dirtyBoxes[e],n=n.concat(p(0,r.x,r.y,r.w,r.h));return n},w=function(e,t){var r;return r=[4],r.push8(t),r.push16(0),r.push32(e),r},_=function(e,t){var r;return r=[5],r.push8(at),r.push16(e),r.push16(t),r},m=function(e){var t,r,i;for(t=[6],t.push8(0),t.push8(0),t.push8(0),t.push32(e.length),i=e.length,r=0;i>r;r+=1)t.push(e.charCodeAt(r));return t},x.connect=function(e,t,r,i){return C=e,R=t,D=void 0!==r?r:"",F=void 0!==i?i:"",C&&R?(c("connect"),void 0):a("Must set host and port")},x.disconnect=function(){c("disconnect","Disconnecting")},x.sendPassword=function(e){D=e,M="Authentication",setTimeout(u,1)},x.sendCtrlAltDel=function(){if("normal"!==M||B.view_only)return!1;Util.Info("Sending Ctrl-Alt-Del");var e=[];e=e.concat(w(65507,1)),e=e.concat(w(65513,1)),e=e.concat(w(65535,1)),e=e.concat(w(65535,0)),e=e.concat(w(65513,0)),e=e.concat(w(65507,0)),e=e.concat(y()),N.send(e)},x.sendKey=function(e,t){if("normal"!==M||B.view_only)return!1;var r=[];"undefined"!=typeof t?(Util.Info("Sending key code ("+(t?"down":"up")+"): "+e),r=r.concat(w(e,t?1:0))):(Util.Info("Sending key code (down + up): "+e),r=r.concat(w(e,1)),r=r.concat(w(e,0))),r=r.concat(y()),N.send(r)},x.clipboardPasteFrom=function(e){"normal"===M&&N.send(m(e))},x.testMode=function(e){st=!0,x.recv_message=N.testMode(e),S=function(){},x.connect=function(e,t,r){C=e,R=t,D=r,c("ProtocolVersion","Starting VNC handshake")}},t()}